<ads-filters>
	<div class="ads-filters" id="ads-filters">
		<div class="block-info block-info-pad-sm">
			<div class="block-info-heading mrg-bottom-md">
				<h4 class="block-info-title-1">ΦΙΛΤΡΑ ΑΝΑΖΗΤΗΣΗΣ</h4>
				<a href="#" class="close hidden-lg hidden-md" onclick="{ close_filters }">&times;</a>
			</div>
			<virtual if="{ state.state_is_ready && state.category.class_type == 'jobs' }">
				<filters-default data-ref="search"></filters-default>
			</virtual>
			<virtual if="{ state.state_is_ready && state.category.class_type == 'realestate' }">
				<filters-realestate data-ref="search" onsubmithandler="{ apply_filters }"></filters-realestate>
			</virtual>
			<virtual if="{ state.state_is_ready && state.category.class_type == 'cars' }">
				<filters-cars data-ref="search"></filters-cars>
			</virtual>
			<virtual if="{ state.state_is_ready && state.category.class_type == 'motors' }">
				<filters-motors data-ref="search"></filters-motors>
			</virtual>
			<virtual if="{ state.state_is_ready && state.category.class_type == 'commercial-vehicles' }">
				<filters-commercial-vehicles data-ref="search"></filters-commercial-vehicles>
			</virtual>
			<virtual if="{ state.state_is_ready && state.category.class_type == 'taxi' }">
				<filters-taxi data-ref="search"></filters-taxi>
			</virtual>
			<virtual if="{ state.state_is_ready && !state.category.class_type }">
				<filters-default data-ref="search"></filters-default>
			</virtual>
	 		<hr>
			<div class="filters-group" show="{ state.show_default_options }">
				<legend>Ενδιαφέρομαι για</legend>
				<div class="checkbox mrg-bottom-sm">
					<label>
						<input type="checkbox" data-ref="media_ads" value="media-ads" checked="{ state.media_ads == 'media-ads' }" onchange="{ checkbox_change }" onkeyup="{ input_keyup }">
						Αγγελίες με φωτογραφία
					</label>
				</div>
				<div class="checkbox mrg-bottom-sm">
					<label>
						<input type="checkbox" data-ref="bargain_ads" value="bargain-ads" checked="{ state.bargain_ads == 'bargain-ads' }" onchange="{ checkbox_change }" onkeyup="{ input_keyup }">
						Ευκαιρίες
					</label>
				</div>
				<div class="checkbox mrg-bottom-sm">
					<label>
						<input type="checkbox" data-ref="member_ads" value="member-ads" checked="{ state.member_ads == 'member-ads' }" onchange="{ checkbox_change }" onkeyup="{ input_keyup }">
						Αγγελίες Ιδιωτών
					</label>
				</div>
				<div class="checkbox">
					<label>
						<input type="checkbox" data-ref="pro_ads" value="pro-ads" checked="{ state.pro_ads == 'pro-ads' }" onchange="{ checkbox_change }" onkeyup="{ input_keyup }">
						Αγγελίες Επαγγελματιών
					</label>
				</div>
			</div>
			<div class="filters-group">
				<legend>Λέξεις κλειδιά</legend>
				<div class="form-group mrg-bottom-none">
					<input type="text" class="form-control" data-ref="keywords" value="{ state.keywords }" onchange="{ input_change }" onkeyup="{ input_keyup }">
				</div>
	 		</div>
	 		<a href="#" class="btn btn-secondary btn-block mrg-bottom-md" onclick="{ apply_filters }">ΕΦΑΡΜΟΓΗ</a>
	 		<hr>
	 		<legend>Κωδικός αγγελίας</legend>
	 		<div class="form-group">
		 		<div class="input-group">
					<input type="text" class="form-control" data-ref="code" value="{ state.code }" placeholder="κωδικός αγγελίας" onkeyup="{ code_change }">
					<span class="input-group-btn">
						<button class="btn btn-primary" title="Αναζήτηση" onclick="{ seach_by_code }"><i class="fa fa-search"></i></button>
					</span>
				</div>
			</div>
	 		<div class="filters-group">
		 		<legend>Ημ/νία Καταχώρησης</legend>
		 		<div class="form-group">
		 			<select class="form-control" data-ref="age" onchange="{ age_change }">
		                <option value="">---</option>
		                <option value="24h" selected="{ state.age == '24h' }">24 ώρες</option>
		                <option value="3d" selected="{ state.age == '3d' }">3 ημέρες</option>
		                <option value="10d" selected="{ state.age == '10d' }">10 ημέρες</option>
		                <option value="30d" selected="{ state.age == '30d' }">30 ημέρες</option>
		            </select>
		        </div>
		    </div>
		    <a href="#" class="clear-filters mrg-bottom-none" onclick="{ clear_filters }">Καθαρισμός επιλογών</a>
		</div>
	</div>

	<script>
		this.state = {
			root_category_slug: "",
			category: {},
			show_default_options: true,
			keywords: "",
			media_ads: "",
			bargain_ads: "",
			member_ads: "",
			pro_ads: "",
			code: "",
			age: "",
			state_is_ready: false,
		}

		this.close_filters = event => {
			event.preventDefault();
			$('#ads-filters').fadeOut(200);
		}

		this.input_keyup = event => {
			if (event.code == "Enter" || event.code == 'NumpadEnter') {
				this.apply_filters();
			}
		}

		this.input_change = event => {
			this.state[event.target.dataset.ref] = event.target.value;
		}

		this.checkbox_change = event => {
			this.state[event.target.dataset.ref] = event.target.checked ? event.target.value : "";
			if (event.target.dataset.ref == 'member_ads' && event.target.checked) {
				this.state.pro_ads = 0;
			} else if (event.target.dataset.ref == 'pro_ads' && event.target.checked) {
				this.state.member_ads = 0;
			}
		}

		this.age_change = event => {
			this.state.age = event.target.value;
			this.apply_filters();
		}

		this.apply_filters = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}
			// Take the search values from the active search tag
			var search = this.refs.search.get_search_values();

			// set the root category for the url
			if (this.state.category.root && this.state.category.root.slug) {
				var category_slug = this.state.category.root.slug;
			} else {
				var category_slug = this.state.category.slug;
			}
			if (search.main_category && search.main_category.slug) {
				category_slug = search.main_category.slug;
			}

			var url = "/category/" + category_slug;
			var params = "";

			if (search.category_slug) {
				url = "/category/" + search.category_slug;
			} else if (search.categories && search.categories.length) {
				params = "?categories=" + search.categories.join(",");
			}

			if (search.location_slug) {
				url+= "/" + search.location_slug;
			} else if (search.locations && search.locations.length) {
				params+= (params ? "&" : "?") + "locations=" + search.locations.join(",");
			} else {
				params+= (params ? "&" : "?") + "pref=0";
			}

			if (search.brands) {
				params+= (params ? "&" : "?") + "brands=" + search.brands;
			}

			if (search.type) {
				params+= (params ? "&" : "?") + "type=" + search.type;
			}

			if (search.price_from || search.price_to) {
				params+= (params ? "&" : "?") + "price=" + min_max_param(search.price_from, search.price_to);
			}
			if (search.area_from || search.area_to) {
				params+= (params ? "&" : "?") + "area=" + min_max_param(search.area_from, search.area_to);
			}

			if (search.year_from || search.year_to) {
				params+= (params ? "&" : "?") + "year=" + min_max_param(search.year_from, search.year_to);
			}
			if (search.cc_from || search.cc_to) {
				params+= (params ? "&" : "?") + "cc=" + min_max_param(search.cc_from, search.cc_to);
			}

			if (search.fuel) {
				params+= (params ? "&" : "?") + "fuel=" + search.fuel;
			}

			var filters = this.refs.search.get_filters();
			var features = filter_features(filters);
			if (features) {
				params+= (params ? "&" : "?") + "features=" + features;
			}
			var options = filter_options(filters);
			if (options) {
				params+= (params ? "&" : "?") + "options=" + options;
			}

			if (this.state.keywords) {
				params+= (params ? "&" : "?") + "keywords=" + this.state.keywords;
			}

			if (this.state.media_ads) {
				params+= (params ? "&" : "?") + this.state.media_ads;
			}
			if (this.state.bargain_ads) {
				params+= (params ? "&" : "?") + this.state.bargain_ads;
			}
			if (this.state.member_ads) {
				params+= (params ? "&" : "?") + this.state.member_ads;
			}
			if (this.state.pro_ads) {
				params+= (params ? "&" : "?") + this.state.pro_ads;
			}

			if (this.state.age) {
				params+= (params ? "&" : "?") + "age=" + this.state.age;
			}

			window.open(window.location.protocol + "//" + window.location.hostname + url + params, "_self");
		}

		this.code_change = event => {
			if (event.code == "Enter" || event.code == 'NumpadEnter') {
				this.seach_by_code();
			} else {
				this.state.code = event.target.value;
			}
		}

		this.seach_by_code = () => {
			window.open(window.location.protocol + "//" + window.location.hostname + "/category/search?code=" + this.state.code, "_self");
		}

		this.clear_filters = event => {
			event.preventDefault();	
			this.refs.search.clear();
			this.state.keywords = "";
			this.state.media_ads = "";
			this.state.bargain_ads = "";
			this.state.member_ads = "";
			this.state.pro_ads = "";
			this.state.code = "";
			this.state.age = "";
			this.update();
			this.apply_filters();
		}

		this.on("mount", function() {
			this.state.category = riot_data.category;

			var root_slug = this.state.category.root ? this.state.category.root.slug : this.state.category.slug;
			this.state.show_default_options = root_slug != 'ergasia' && root_slug != 'xarise-to' && root_slug != 'koinwnika-proswpika';
			if (this.state.show_default_options) {
				this.state.media_ads = riot_data.media_ads ? riot_data.media_ads : "";
				this.state.bargain_ads = riot_data.bargain_ads ? riot_data.bargain_ads : "";
				this.state.member_ads = riot_data.member_ads ? riot_data.member_ads : "";
				this.state.pro_ads = riot_data.pro_ads ? riot_data.pro_ads : "";
			}

			if (riot_data.keywords) {
				this.state.keywords = decodeURIComponent(riot_data.keywords);
			}

			this.state.code = riot_data.code ? riot_data.code : "";
			this.state.age = riot_data.age ? riot_data.age : "";
			this.state.state_is_ready = true;
			this.update();

			// filters toggler handler
			$('.filters-button').bind("click", function(event) {
				event.preventDefault();
				
				if ($('#ads-filters').is("visible")) {
					$('#ads-filters').fadeOut(200);
				} else {
					$('#ads-filters').fadeIn(200);
				}
			})
		});
	</script>
</ads-filters>